package com.TianGe9158;

import java.nio.ByteBuffer;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.Canvas;
import android.graphics.Rect;
import android.view.View;

//import android.graphics.Paint;

public class VideoPlay extends View {
	int m_nWidth = 320; // ˴趨ͬķֱ
	int m_nHeight = 240;
	int m_nLength = 0;
	public AVModule m_AVModuel = null;
	int m_nShowWidth = 0;
	int m_nShowHeight = 0;
	int x_offset = 0;
	int y_offset = 0;

	int m_nShowWidth_lian = 0;
	int m_nShowHeight_lian = 0;
	int x_offset_lian = 0;
	int y_offset_lian = 0;

	byte[] m_Pixel = null;
	// byte [] m_realPixels =null;

	ByteBuffer m_buffer = null;
	Bitmap m_VideoBmp = null;
	Rect m_rect = new Rect(0, 0, 320, 240);
	Rect m_srcRect = new Rect(0, 0, 320, 240);
	Rect m_srcRect_lian = new Rect(0, 0, 320, 240);

	boolean m_bStop = false;

	private Boolean refreshUi = false;
	private int newWidth = 0, newHeight = 0;

	public VideoPlay(Context context) {
		super(context);
	}

	/*
	 * public void SetPlayRect(int left, int top, int right, int bottom){
	 * m_rect.set(0, 0, getWidth(), getHeight());
	 * 
	 * }
	 */
	public void SetPlayRect() {
		// m_rect.set(0, 0, getWidth(), getHeight());
		// Log.v("cress is OK", "SetPlayRect" + getWidth() + " " + getHeight());
		m_rect.set(0, 0, getWidth(), getHeight());

	}

	public void Stop() {
		m_bStop = true;
	}

	public void Close() {
		m_rect = null;
		m_VideoBmp = null;
		m_buffer = null;
		m_Pixel = null;
	}

	public void Close2() {
		// m_rect = null;
		// m_VideoBmp = null;
		m_buffer = null;
		m_Pixel = null;
	}

	public void Init(int width, int height) {
		m_bStop = false;
		m_nWidth = width;
		m_nHeight = height;
		m_nLength = height * width * 2;
		m_Pixel = new byte[m_nLength];
		for (int i = 0; i < m_Pixel.length; i++) {
			m_Pixel[i] = (byte) 255;
		}

		m_buffer = ByteBuffer.wrap(m_Pixel);

	}

	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		if (m_bStop)
			return;

		if ((m_Pixel != null && m_VideoBmp == null) || refreshUi) {
			m_rect.set(0, 0, getWidth(), getHeight());
			float src_scale = ((float) m_nWidth) / ((float) m_nHeight);
			float dest_scale = ((float) getWidth()) / ((float) getHeight());
			
			if (refreshUi && newWidth != 0 && newHeight != 0) {
				dest_scale = ((float) newWidth) / ((float) newHeight);
			}
			refreshUi = false;

			m_nShowWidth = m_nWidth;
			m_nShowHeight = m_nHeight;
			x_offset = 0;
			y_offset = 0;
			if (src_scale > dest_scale) {
				m_nShowWidth = (int) (m_nShowHeight * dest_scale) / 2 * 2;
				x_offset = (m_nWidth - m_nShowWidth) / 2;
			} else {
				m_nShowHeight = (int) (m_nShowWidth / dest_scale) / 2 * 2;
				y_offset = (m_nHeight - m_nShowHeight) / 2;
			}
			m_VideoBmp = Bitmap.createBitmap(m_nWidth, m_nHeight, Config.RGB_565);
			m_srcRect.set(x_offset, y_offset, m_nShowWidth + x_offset, m_nShowHeight + y_offset);

			float src_scaleLian = ((float) m_nWidth) / ((float) m_nHeight) / 2.0f;
			m_nShowWidth_lian = m_nWidth / 2;
			m_nShowHeight_lian = m_nHeight;
			x_offset_lian = 0;
			y_offset_lian = 0;
			if (src_scaleLian > dest_scale) {
				m_nShowWidth_lian = (int) (m_nShowHeight_lian * dest_scale) / 2 * 2;
				x_offset_lian = (m_nWidth - m_nShowWidth_lian) / 2;
			} else {
				m_nShowHeight_lian = (int) (m_nShowWidth_lian / dest_scale) / 2 * 2;
				y_offset_lian = (m_nHeight - m_nShowHeight_lian) / 2;
			}

			m_VideoBmp = Bitmap.createBitmap(m_nWidth, m_nHeight, Config.RGB_565);
			m_srcRect.set(x_offset, y_offset, m_nShowWidth + x_offset, m_nShowHeight + y_offset);
			// m_srcRect_lian.set(x_offset_lian, y_offset_lian,
			// m_nShowWidth_lian + x_offset_lian, m_nShowHeight_lian
			// + y_offset_lian);
			m_srcRect_lian.set(m_nWidth / 4, y_offset, m_nWidth * 3 / 4, m_nShowHeight + y_offset);
		}
		if (m_VideoBmp == null)
			return;

		m_buffer.position(0);
		m_VideoBmp.copyPixelsFromBuffer(m_buffer);

		if (m_AVModuel != null && m_AVModuel.getIsLianMai()) {
			canvas.drawBitmap(m_VideoBmp, m_srcRect_lian, m_rect, null);// gf
		} else {
			canvas.drawBitmap(m_VideoBmp, m_srcRect, m_rect, null);// gf
		}

		// Bitmap tmpBit = Bitmap.createBitmap(mPixel, 320, 480,
		// Bitmap.Config.RGB_565);//.ARGB_8888);

		// VideoBit.copyPixelsFromBuffer(buffer);//makeBuffer(data565, N));
		// canvas.drawBitmap(VideoBit, 0, 0, null);
	}

	// int tmp = 1;
	/*
	 * public void InitVideoBuffer(byte []buffer, int nLength) {
	 * System.arraycopy(buffer, 0, m_Pixel, 0, m_nLength); }
	 */
	public void AddVideoBuffer(byte[] buffer, int nLength) {
		if (m_bStop || m_nLength > nLength)
			return;

		// m_AVModuel.VideoScaleClip(buffer, m_nWidth, m_nHeight, pOutBuffer,
		// nDstwidth, nDstheight);

		System.arraycopy(buffer, 0, m_Pixel, 0, m_nLength);
		postInvalidate();
	}

	public void SetAVModule(AVModule avModule) {
		m_AVModuel = avModule;
	}

	public Boolean getRefreshUi() {
		return refreshUi;
	}

	public void setRefreshUi(Boolean refreshUi) {
		this.refreshUi = refreshUi;
	}

	public int getNewWidth() {
		return newWidth;
	}

	public void setNewWidth(int newWidth) {
		this.newWidth = newWidth;
	}

	public int getNewHeight() {
		return newHeight;
	}

	public void setNewHeight(int newHeight) {
		this.newHeight = newHeight;
	}
}
