package com.TianGe9158;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

public class ConfigDlg extends Dialog implements OnClickListener {
	
	
	private Button           ButtonOK;
    private Button           ButtonCancel;
    public AVConfig 		 m_config = null; 
	 public ConfigDlg(Context context) { 
	        super(context);
	    }
	 
	 @Override
	 protected void onCreate(Bundle savedInstanceState) {
	     super.onCreate(savedInstanceState);
	     //Log.v(TestApp, Dialog created);
	     setContentView(R.layout.configdlg);
	     setTitle("");
	 //    requestWindowFeature(Window.FEATURE_NO_TITLE);
	     ButtonOK = (Button) findViewById(R.id.ButtonOK);
	     ButtonCancel = (Button) findViewById(R.id.ButtonCancel);
	     
	     ButtonOK.setOnClickListener(this);
	     ButtonCancel.setOnClickListener(this);
	     
	     ((EditText) findViewById(R.id.EditTextIP)).setText(m_config.m_sIP);
	     ((EditText) findViewById(R.id.EditTextPort)).setText(String.valueOf(m_config.m_nPort)); 
	     ((EditText) findViewById(R.id.EditTextRoomID)).setText(String.valueOf(m_config.m_nRoomID)); 
	     ((EditText) findViewById(R.id.EditTextUserID)).setText(String.valueOf(m_config.m_nUserID)); 
	     ((EditText) findViewById(R.id.EditTextWidth)).setText(String.valueOf(m_config.m_nWidth)); 
	     ((EditText) findViewById(R.id.EditTextHeight)).setText(String.valueOf(m_config.m_nHeight));
	      
	}
	 
	 @Override
	 public void onClick(View view) {
		 int viewid=view.getId();
		 if(viewid==R.id.ButtonOK) {
		 		m_config.m_sIP = ((EditText) findViewById(R.id.EditTextIP)).getText().toString();
		 		m_config.m_nPort = Integer.parseInt( ((EditText) findViewById(R.id.EditTextPort)).getText().toString());
		 		m_config.m_nRoomID = Integer.parseInt(((EditText) findViewById(R.id.EditTextRoomID)).getText().toString());
		 		m_config.m_nUserID = Integer.parseInt(((EditText) findViewById(R.id.EditTextUserID)).getText().toString());
		 		m_config.m_nWidth = Integer.parseInt(((EditText) findViewById(R.id.EditTextWidth)).getText().toString());
		 		m_config.m_nHeight = Integer.parseInt(((EditText) findViewById(R.id.EditTextHeight)).getText().toString());	
				dismiss();
		 }else{
			 if(viewid==R.id.ButtonCancel){
	            cancel();
	            }
	     }
	 }

}

